package main

// Imports
import (
	"Gover/Configuration"
	"Gover/Module"
	"net/http"
)

var configurationDirectory string

// Main
func main() {
	// HTTP Handler
	httpHandler := http.NewServeMux()
	// Configurations
	configurations, err := Configuration.LoadConfigurations(configurationDirectory)

	println("Dir:")
	println(configurationDirectory)
	// Handle Error
	if err != nil {
		panic(err)
	}
	// Validate Configurations
	err = Configuration.ValidateConfigurations(configurations)
	// Handle Error
	if err != nil {
		panic(err)
	}
	// Configuration Number
	var configurationNumber uint
	// Loop Over Configurations
	for configurationNumber = 0; configurationNumber < uint(len(configurations)); configurationNumber++ {
		// Add Modules
		Module.AddModules(configurations[configurationNumber], httpHandler)
	}
	// Listen And Serve
	err = http.ListenAndServe(":80", httpHandler)
	// Handle Error
	if err != nil {
		panic(err)
	}
}
